//----------------------------------------------------------------------------------------
// MTwist Down Lists.cp
// ETO20 MacApp 3.3.1, MPW 3.4.1
// Copyright 1994-1996 Conrad Kopala
// Twist Down Lists version 2.0a0 7/15/96
//----------------------------------------------------------------------------------------

#ifndef __UTWISTDOWNGLOBALS__
#include "UTwistDownGlobals.h"
#endif

#ifndef __UTWISTDOWNAPP__
#include "UTwistDownApp.h"
#endif

#ifndef __UVOLUMEBASEDAPP__
#include "UVolumeBasedApp.h"
#endif

#ifndef __UTWISTDOWNCONTROL__
#include "UTwistDownControl.h"
#endif

#ifndef __UTWISTDOWNVIEW__
#include "UTwistDownView.h"
#endif

#ifndef __UPROGRESSDIALOG__
#include "UProgressIndicators.h"
#endif

//MacApp stuff

#ifndef __UDEBUG__
#include "UDebug.h"
#endif

#ifndef __UPRINTING__
#include "UPrinting.h"
#endif

#ifndef __UMACAPPUTILITIES__
#include "UMacAppUtilities.h"
#endif

#ifndef __UERRORMGR__
#include "UErrorMgr.h"
#endif

#ifndef __UDIALOG__
#include "UDialog.h"
#endif

#ifndef __UGRIDVIEW__
#include "UGridView.h"
#endif

#ifndef __UMACAPPGLOBALS__
#include "UMacAppGlobals.h"
#endif

//ToolBox stuff
//None

//ANSI stuff
//None

// Generate universal code
#pragma push
#pragma processor 68000

//----------------------------------------------------------------------------------------
// main: 
//----------------------------------------------------------------------------------------
#pragma segment Main

void main ()
{

#if qDebug
	InitUDebugGlobals();
//InitUDebugGlobals() sets the following global. 
	gObjectCount = 0;
//InitUDebugGlobals() sets the following globals to FALSE. You may want to change
//their initial values as I do with gObjectCountingEnabled.
	gObjectCountingEnabled = TRUE;
	gPrintBaseClassInfo = FALSE;
	gPrintMacAppClassInfo = FALSE; 	//To watch MacApp start up, set this to true.
	gPrintAppClassInfo = FALSE;			//To watch your app start up, set this to true.
	gAppUserFlag1 = FALSE;
	gAppUserFlag2 = FALSE;
	gAppUserFlag3 = FALSE;
#endif

	gFailHere = FALSE;
	
	InitUMacApp(64);
	gOHRemainingIncrements = InitMaxObjectHeapSize();

	InitUTEView();
	InitUGridView();
	InitUPrinting();
	InitUDialog();

	InitUTwistDownControl();	
	InitUTwistDownView();
	InitUProgressDialog();

	TTwistDownApp* aTwistDownApp = NULL;
	aTwistDownApp = new TTwistDownApp;
	aTwistDownApp -> ITwistDownApp(kHasSplashScreen);
	
	aTwistDownApp -> Run();
	
/*	
#if qDebug
//I use this to give me a count of the objects just before the app terminates.
//Generally, you would expect that count to be the same as it is just after the
//app enters MainEventLoop. It isn't. MacApp doesn't free everything when an
//application terminates.
fprintf(stderr, "Main after Run");
PrintObjectCount();
fprintf(stderr, "\n");
#endif	
*/

}

#pragma pop
#pragma segment Inline